<template>
  <div>

    <select v-model="filter">
      <option value="1" selected>Brand</option>
      <option value="2">Color</option>
      <option value="3">Price</option>
      <option value="4">Year</option>
    </select> |
    <input v-model="search" type="text" placeholder="Search" /> <br /><br />

    <button @click="$router.push('/add')">Додати телефон до каталогу</button>
    <hr />

    <div>
      <div v-if="isLoading">Loading......</div>
      <div v-else>
        <div v-for="phone in filteredItems" :key="phone.id">
          {{ phone.brand }} - {{ phone.price + ' грн.'}}
          <button @click="$router.push(`/${phone.id}`)">Show</button>
          <button @click="$router.push(`/${phone.id}/edit`)">Edit</button>
          <button @click="deleteItem(phone.id)">Delete</button> <br /> <br />
        </div>
      </div>
    </div>

  </div>
</template>

<script>
import { mapGetters, mapActions } from 'vuex'

export default {
  name: 'CatalogPage',

  data() {
    return {
      search: '',
      filter: '',
    }
  },

  props: {
    phone: {
      type: Object,
    },
  },

  computed: {
    ...mapGetters('phones', ['getItemsList', 'isLoading']),

    filteredItems() {
      if (this.filter == "1") {
        return this.getItemsList.filter((object) => {
          return object.brand.toLowerCase().includes(this.search.toLowerCase());
        });
      }
      else if (this.filter == "2") {
        return this.getItemsList.filter((object) => {
          return String(object.color).includes(this.search);
        });
      }
      else if (this.filter =="3") {
        return this.getItemsList.filter((object) => {
          return String(object.price).includes(this.search);
        });
      }
      else if (this.filter =="4") {
        return this.getItemsList.filter((object) => {
          return String(object.age).includes(this.search);
        });
      }
      else {
        return this.getItemsList;
      }
    },
  },

  created() {
    this.loadList();
  },

  methods: {
    ...mapActions('phones', ['loadList', 'addItem', 'deleteItem', 'updateItem', 'loadFilteredData']),
  },
}
</script>

<style lang="css" scoped>

</style>